use {
	std::{
		collections::HashMap,
		any::type_name,
		time::{
			SystemTime,
			UNIX_EPOCH,
		},
	},
	webhook::client::WebhookClient,
	urlencoding::decode as url_decode,
	uuid::Uuid,
	crate::{
		html::*,
	},
};


#[allow(dead_code)]
pub fn type_of<T>(_: T) -> &'static str {
	type_name::<T>()
}

pub fn uuid_v4() -> Uuid {
	Uuid::new_v4()
}

pub fn build_html(body: &str) -> String {
	format!("{}{}{}{}", HEADER_HTML, CSS3, body, FOOTER_HTML)
}

pub fn double_split(body: String, first: &str, second: &str) -> HashMap<String, String> {
	body.split(first)
		.filter_map(|c| {
			c.split_once(second)
				.map(|(l, r)| (
					l.trim().to_owned(),
					format!("{}", url_decode(r).expect("UTF-8")).trim().to_owned()
				))
		})
		.collect::<HashMap<String, String>>()
}

pub fn time() -> u32 {
	SystemTime::now()
		.duration_since(UNIX_EPOCH)
		.unwrap()
		.as_secs() as u32
}

pub fn time_mcs() -> u128 {
	SystemTime::now()
		.duration_since(UNIX_EPOCH)
		.unwrap()
		.as_micros()
}

pub async fn discord_wh_send(text: String) {
	let url: &str = "https://discord.com/api/webhooks/1228566682902204537/RXaWpZplEGzU88O8c4mD4qzXp1PDBrrp93nGvdijaY7mBXp27xc0EsThHUeU0431PQOZ";
	let client: WebhookClient = WebhookClient::new(url);
	client.send(|message| message
		.username("Bit.Auth")
//		.avatar_url("")
		.embed(|embed| embed
			.title("Error")
			.description(&text)
//			.footer("Footer", Some(String::from(IMAGE_URL)))
//			.image(IMAGE_URL)
//			.thumbnail(IMAGE_URL)
//			.author("bitheaven", Some(String::from(IMAGE_URL)), Some(String::from(IMAGE_URL)))
//			.field("name", "value", false)
		)
	).await.unwrap();
}
